/*--------------------------------------------------------------------------+
$Id$
|                                                                          |
| Copyright 2011 ForTISS GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.tooling.kernel;

import org.eclipse.core.runtime.Plugin;
import org.fortiss.tooling.kernel.introspection.KernelIntrospectionSystemService;
import org.fortiss.tooling.kernel.service.ICommandStackService;
import org.fortiss.tooling.kernel.service.IConnectionCompositorService;
import org.fortiss.tooling.kernel.service.IConstraintCheckerService;
import org.fortiss.tooling.kernel.service.IElementCompositorService;
import org.fortiss.tooling.kernel.service.ILibraryService;
import org.fortiss.tooling.kernel.service.IMigrationService;
import org.fortiss.tooling.kernel.service.IPersistencyService;
import org.fortiss.tooling.kernel.service.IPrototypeService;
import org.fortiss.tooling.kernel.service.ITransformationService;
import org.osgi.framework.BundleContext;

/**
 * The activator class controls the plug-in life cycle.
 * 
 * @author hoelzl
 * @author $Author$
 * @version $Rev$
 * @ConQAT.Rating YELLOW Hash: 66981719E8162DD7966D7A81934C07C3
 */
public class ToolingKernelActivator extends Plugin {

	/** The plug-in ID. */
	public static final String PLUGIN_ID = ToolingKernelActivator.class.getPackage().getName(); //$NON-NLS-1$

	/** The shared instance. */
	private static ToolingKernelActivator plugin;

	/** {@inheritDoc} */
	@Override
	public void start(BundleContext context) throws Exception {
		super.start(context);
		plugin = this;

		initializeServices();
	}

	/** Initializes the kernel services by calling its singleton {@code toString()} method. */
	private void initializeServices() {
		KernelIntrospectionSystemService.INSTANCE.toString();

		ICommandStackService.INSTANCE.toString();
		IConnectionCompositorService.INSTANCE.toString();
		IConstraintCheckerService.INSTANCE.toString();
		// FIXME: IConstraintVerificationService.INSTANCE.toString();
		IElementCompositorService.INSTANCE.toString();
		ILibraryService.INSTANCE.toString();
		// FIXME: ILoggingService.INSTANCE.toString();
		IMigrationService.INSTANCE.toString();
		IPersistencyService.INSTANCE.toString();
		IPrototypeService.INSTANCE.toString();
		ITransformationService.INSTANCE.toString();
		// ITutorialService.INSTANCE.toString();
	}

	/** {@inheritDoc} */
	@Override
	public void stop(BundleContext context) throws Exception {
		plugin = null;
		super.stop(context);
	}

	/** Returns the shared instance. */
	public static ToolingKernelActivator getDefault() {
		return plugin;
	}
}
